// Desativando a regra 'no-title-in-document-head' do ESLint para este arquivo.
/* eslint-disable @next/next/no-title-in-document-head */

// Importando os componentes necessários do pacote 'next/document'.
import Document, {
  DocumentContext,
  Head,
  Html,
  Main,
  NextScript,
} from "next/document";

// Importando 'ServerStyleSheet' de 'styled-components' para lidar com a renderização do lado do servidor.
import { ServerStyleSheet } from "styled-components";

// Criando uma nova classe 'MyDocument' que estende 'Document'.
export default class MyDocument extends Document {
  // Definindo 'getInitialProps' para lidar com a renderização inicial do lado do servidor.
  static async getInitialProps(ctx: DocumentContext) {
    const sheet = new ServerStyleSheet();
    const originalRenderPage = ctx.renderPage;

    try {
      // Melhorando a função 'renderPage' para coletar estilos do 'styled-components'.
      ctx.renderPage = () =>
        originalRenderPage({
          enhanceApp: (App) => (props) =>
            sheet.collectStyles(<App {...props} />),
        });

      // Obtendo as propriedades iniciais do Documento.
      const initialProps = await Document.getInitialProps(ctx);
      return {
        ...initialProps,
        // Incluindo os estilos coletados do 'styled-components' nas propriedades iniciais.
        styles: (
          <>
            {initialProps.styles}
            {sheet.getStyleElement()}
          </>
        ),
      };
    } finally {
      // Selando a 'ServerStyleSheet' para evitar vazamentos de memória.
      sheet.seal();
    }
  }

  // Renderizando o documento personalizado.
  render() {
    return (
      <Html>
        <Head>
          <meta name="description" content="Generated by create next app" />
          <link rel="icon" href="/telelogo2.png" />
          <link rel="preconnect" href="https://fonts.googleapis.com" />
          <link
            rel="preconnect"
            href="https://fonts.gstatic.com"
            crossOrigin="true"
          />
          <link
            href="https://fonts.googleapis.com/css2?family=Montserrat:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&display=swap"
            rel="stylesheet"
          />
          <link href="https://fonts.googleapis.com/css2?family=Poppins:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&display=swap" rel="stylesheet" />
          <link href="https://fonts.googleapis.com/css2?family=Urbanist:ital,wght@0,100..900;1,100..900&display=swap" rel="stylesheet"></link>
          <link href="https://fonts.googleapis.com/css2?family=Inter:wght@100..900&family=Urbanist:ital,wght@0,100..900;1,100..900&display=swap" rel="stylesheet"></link>
        </Head>
        <body>
          <Main />
          <div id="modal-portal" />
          <NextScript />
        </body>
      </Html>
    );
  }
}
